SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Compiler'!

TestCase subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:13'!
match: aString with: aRule

	[ACParser matchAll: aString with: aRule]
		on: OM2Fail
		do: [^ false].
	^ true! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:10'!
testUserStoryMatch

	self should: [ 
		self match: 
'In order to achieve something
As a role
I want to do some thing.'
			with: #userStory].! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:10'!
testUserStoryMeansMatch

	self should: [self match: 'I want to do something' with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:10'!
testUserStoryPurposeMatch

	self should: [  self match: 'In order to achieve something' with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:10'!
testUserStoryRoleMatch

	self should: [ self match: 'As a role' with: #roleLine].! !

OMeta2 subclass: #ACParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:05'!
meansLine =

	spaces <``I want to''> spaces <charNoNewline+>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:05'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:05'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 17:50'!
test =

		 $a <char:x ?[x = Character cr]> $b! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 17:54'!
userStory =
	
	purposeLine lineEnd
	roleLine lineEnd
	meansLine lineEnd?
	! !
